package org.diagbot.nlp.rule.pretreat;

import org.diagbot.nlp.participle.ParticipleUtil;
import org.diagbot.nlp.participle.word.Lexeme;
import org.diagbot.nlp.participle.word.LexemePath;
import org.diagbot.nlp.rule.module.PreResult;
import org.diagbot.nlp.util.NegativeEnum;
import org.diagbot.nlp.util.NlpUtil;

import java.util.ArrayList;
import java.util.List;

public class PretreatmentOther extends Pretreatment {
    protected NegativeEnum[] nees_married = new NegativeEnum[]{NegativeEnum.MARRIED_DESC};

    public List<PreResult> analyze(String content) throws java.io.IOException{
        List<PreResult> preResults = super.analyzeDefault(content);
        for (PreResult result : preResults) {
            result.setUniqueName("其他--" + result.getUniqueName());
        }

        LexemePath<Lexeme> lexemes = ParticipleUtil.participle(content);
        for (int i = 0; i < lexemes.size(); i++) {
            Lexeme l = lexemes.get(i);
            PreResult result = new PreResult();
            if (NlpUtil.isFeature(l.getProperty(), nees_married)) {
                result.setUniqueName("其他--");
                result.setDetailName("其他--");
                result.setValue(NlpUtil.concept(l, NegativeEnum.MARRIED_DESC));
                preResults.add(result);
            }
        }
        return preResults;
    }

    public PreResult createPreResult(LexemePath<Lexeme> lexemes, Lexeme lexeme, int index) {
        return super.createDefaultPreResult(lexemes, lexeme, index);
    }

    public String findBodyValue(LexemePath<Lexeme> lexemes, Lexeme lexeme, int index) {
        if (cursor > 0) cursor--;
        int search_len = 0;
        Lexeme leftLexeme = null;
        while (search_len < max_back_search && cursor > -1) {
            leftLexeme = lexemes.get(cursor);
            if (NlpUtil.isFeature(leftLexeme.getProperty(), new NegativeEnum[]{NegativeEnum.MARRIED_DESC})) {
                return NlpUtil.concept(leftLexeme, NegativeEnum.MARRIED_DESC);
            }
            search_len++;
            cursor--;
        }
        return null;
    }
}
