package org.diagbot.nlp.similar;

import org.diagbot.nlp.participle.cfg.Configuration;
import org.diagbot.nlp.participle.cfg.DefaultConfig;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author: HUJING
 * @Date: 2019/10/16 15:30
 */
public class SimilarCacheUtil {
    //相似度知识库
    public static Map<String, List<String>> similar_dict_map = null;

    public static Map<String, List<String>> getSimilar_dict_map() {
        if (similar_dict_map == null) {
            createSimilar_dict_map();
        }
        return similar_dict_map;
    }

    public static Map<String, List<String>> createSimilar_dict_map() {
        similar_dict_map = new HashMap<>();
        List<String> similarList = null;
        Configuration configuration = new DefaultConfig();
        List<String> fileContents = configuration.readTargetFileContents("bigdata_similar.dict");
        for (String line:fileContents) {
            String[] similarPair = line.split("\\|", -1);
            if (similar_dict_map.get(similarPair[0]) == null){
                similarList = new ArrayList<>();
                similarList.add(similarPair[1]);
                similar_dict_map.put(similarPair[0],similarList);
            } else {
                similar_dict_map.get(similarPair[0]).add(similarPair[1]);
            }
        }
        return similar_dict_map;
    }
}
